Code

rename git-p4 tests
authorPete Wyckoff <pw@padd.com>
Sun, 25 Dec 2011 02:07:30 +0000 (21:07 -0500)
committerJunio C Hamano <gitster@pobox.com>
Tue, 27 Dec 2011 18:19:06 +0000 (10:19 -0800)
Use consistent naming for all tests: "t98<num>-git-p4-<topic>.sh"

Signed-off-by: Pete Wyckoff <pw@padd.com>
Signed-off-by: Junio C Hamano <gitster@pobox.com>
t/t9800-git-p4-basic.sh [new file with mode: 0755]
t/t9800-git-p4.sh [deleted file]
t/t9803-git-p4-shell-metachars.sh [new file with mode: 0755]
t/t9803-git-shell-metachars.sh [deleted file]
t/t9805-git-p4-skip-submit-edit.sh [new file with mode: 0755]
t/t9805-skip-submit-edit.sh [deleted file]
t/t9807-git-p4-submit.sh [new file with mode: 0755]
t/t9807-submit.sh [deleted file]
t/t9808-chdir.sh [deleted file]
t/t9808-git-p4-chdir.sh [new file with mode: 0755]

diff --git a/t/t9800-git-p4-basic.sh b/t/t9800-git-p4-basic.sh
new file mode 100755 (executable)
index 0000000..272de3f
--- /dev/null
@@ -0,0 +1,404 @@
+#!/bin/sh
+
+test_description='git-p4 tests'
+
+. ./lib-git-p4.sh
+
+test_expect_success 'start p4d' '
+       start_p4d
+'
+
+test_expect_success 'add p4 files' '
+       (
+               cd "$cli" &&
+               echo file1 >file1 &&
+               p4 add file1 &&
+               p4 submit -d "file1" &&
+               echo file2 >file2 &&
+               p4 add file2 &&
+               p4 submit -d "file2"
+       )
+'
+
+test_expect_success 'basic git-p4 clone' '
+       "$GITP4" clone --dest="$git" //depot &&
+       test_when_finished cleanup_git &&
+       (
+               cd "$git" &&
+               git log --oneline >lines &&
+               test_line_count = 1 lines
+       )
+'
+
+test_expect_success 'git-p4 clone @all' '
+       "$GITP4" clone --dest="$git" //depot@all &&
+       test_when_finished cleanup_git &&
+       (
+               cd "$git" &&
+               git log --oneline >lines &&
+               test_line_count = 2 lines
+       )
+'
+
+test_expect_success 'git-p4 sync uninitialized repo' '
+       test_create_repo "$git" &&
+       test_when_finished cleanup_git &&
+       (
+               cd "$git" &&
+               test_must_fail "$GITP4" sync
+       )
+'
+
+#
+# Create a git repo by hand.  Add a commit so that HEAD is valid.
+# Test imports a new p4 repository into a new git branch.
+#
+test_expect_success 'git-p4 sync new branch' '
+       test_create_repo "$git" &&
+       test_when_finished cleanup_git &&
+       (
+               cd "$git" &&
+               test_commit head &&
+               "$GITP4" sync --branch=refs/remotes/p4/depot //depot@all &&
+               git log --oneline p4/depot >lines &&
+               test_line_count = 2 lines
+       )
+'
+
+test_expect_success 'exit when p4 fails to produce marshaled output' '
+       badp4dir="$TRASH_DIRECTORY/badp4dir" &&
+       mkdir "$badp4dir" &&
+       test_when_finished "rm \"$badp4dir/p4\" && rmdir \"$badp4dir\"" &&
+       cat >"$badp4dir"/p4 <<-EOF &&
+       #!$SHELL_PATH
+       exit 1
+       EOF
+       chmod 755 "$badp4dir"/p4 &&
+       PATH="$badp4dir:$PATH" "$GITP4" clone --dest="$git" //depot >errs 2>&1 ; retval=$? &&
+       test $retval -eq 1 &&
+       test_must_fail grep -q Traceback errs
+'
+
+test_expect_success 'add p4 files with wildcards in the names' '
+       (
+               cd "$cli" &&
+               echo file-wild-hash >file-wild#hash &&
+               echo file-wild-star >file-wild\*star &&
+               echo file-wild-at >file-wild@at &&
+               echo file-wild-percent >file-wild%percent &&
+               p4 add -f file-wild* &&
+               p4 submit -d "file wildcards"
+       )
+'
+
+test_expect_success 'wildcard files git-p4 clone' '
+       "$GITP4" clone --dest="$git" //depot &&
+       test_when_finished cleanup_git &&
+       (
+               cd "$git" &&
+               test -f file-wild#hash &&
+               test -f file-wild\*star &&
+               test -f file-wild@at &&
+               test -f file-wild%percent
+       )
+'
+
+test_expect_success 'clone bare' '
+       "$GITP4" clone --dest="$git" --bare //depot &&
+       test_when_finished cleanup_git &&
+       (
+               cd "$git" &&
+               test ! -d .git &&
+               bare=`git config --get core.bare` &&
+               test "$bare" = true
+       )
+'
+
+p4_add_user() {
+       name=$1 fullname=$2 &&
+       p4 user -f -i <<-EOF &&
+       User: $name
+       Email: $name@localhost
+       FullName: $fullname
+       EOF
+       p4 passwd -P secret $name
+}
+
+p4_grant_admin() {
+       name=$1 &&
+       {
+               p4 protect -o &&
+               echo "    admin user $name * //depot/..."
+       } | p4 protect -i
+}
+
+p4_check_commit_author() {
+       file=$1 user=$2 &&
+       p4 changes -m 1 //depot/$file | grep -q $user
+}
+
+make_change_by_user() {
+       file=$1 name=$2 email=$3 &&
+       echo "username: a change by $name" >>"$file" &&
+       git add "$file" &&
+       git commit --author "$name <$email>" -m "a change by $name"
+}
+
+# Test username support, submitting as user 'alice'
+test_expect_success 'preserve users' '
+       p4_add_user alice Alice &&
+       p4_add_user bob Bob &&
+       p4_grant_admin alice &&
+       "$GITP4" clone --dest="$git" //depot &&
+       test_when_finished cleanup_git &&
+       (
+               cd "$git" &&
+               echo "username: a change by alice" >>file1 &&
+               echo "username: a change by bob" >>file2 &&
+               git commit --author "Alice <alice@localhost>" -m "a change by alice" file1 &&
+               git commit --author "Bob <bob@localhost>" -m "a change by bob" file2 &&
+               git config git-p4.skipSubmitEditCheck true &&
+               P4EDITOR=touch P4USER=alice P4PASSWD=secret "$GITP4" commit --preserve-user &&
+               p4_check_commit_author file1 alice &&
+               p4_check_commit_author file2 bob
+       )
+'
+
+# Test username support, submitting as bob, who lacks admin rights. Should
+# not submit change to p4 (git diff should show deltas).
+test_expect_success 'refuse to preserve users without perms' '
+       "$GITP4" clone --dest="$git" //depot &&
+       test_when_finished cleanup_git &&
+       (
+               cd "$git" &&
+               git config git-p4.skipSubmitEditCheck true &&
+               echo "username-noperms: a change by alice" >>file1 &&
+               git commit --author "Alice <alice@localhost>" -m "perms: a change by alice" file1 &&
+               P4EDITOR=touch P4USER=bob P4PASSWD=secret test_must_fail "$GITP4" commit --preserve-user &&
+               test_must_fail git diff --exit-code HEAD..p4/master
+       )
+'
+
+# What happens with unknown author? Without allowMissingP4Users it should fail.
+test_expect_success 'preserve user where author is unknown to p4' '
+       "$GITP4" clone --dest="$git" //depot &&
+       test_when_finished cleanup_git &&
+       (
+               cd "$git" &&
+               git config git-p4.skipSubmitEditCheck true &&
+               echo "username-bob: a change by bob" >>file1 &&
+               git commit --author "Bob <bob@localhost>" -m "preserve: a change by bob" file1 &&
+               echo "username-unknown: a change by charlie" >>file1 &&
+               git commit --author "Charlie <charlie@localhost>" -m "preserve: a change by charlie" file1 &&
+               P4EDITOR=touch P4USER=alice P4PASSWD=secret test_must_fail "$GITP4" commit --preserve-user &&
+               test_must_fail git diff --exit-code HEAD..p4/master &&
+
+               echo "$0: repeat with allowMissingP4Users enabled" &&
+               git config git-p4.allowMissingP4Users true &&
+               git config git-p4.preserveUser true &&
+               P4EDITOR=touch P4USER=alice P4PASSWD=secret "$GITP4" commit &&
+               git diff --exit-code HEAD..p4/master &&
+               p4_check_commit_author file1 alice
+       )
+'
+
+# If we're *not* using --preserve-user, git-p4 should warn if we're submitting
+# changes that are not all ours.
+# Test: user in p4 and user unknown to p4.
+# Test: warning disabled and user is the same.
+test_expect_success 'not preserving user with mixed authorship' '
+       "$GITP4" clone --dest="$git" //depot &&
+       test_when_finished cleanup_git &&
+       (
+               cd "$git" &&
+               git config git-p4.skipSubmitEditCheck true &&
+               p4_add_user derek Derek &&
+
+               make_change_by_user usernamefile3 Derek derek@localhost &&
+               P4EDITOR=cat P4USER=alice P4PASSWD=secret "$GITP4" commit |\
+               grep "git author derek@localhost does not match" &&
+
+               make_change_by_user usernamefile3 Charlie charlie@localhost &&
+               P4EDITOR=cat P4USER=alice P4PASSWD=secret "$GITP4" commit |\
+               grep "git author charlie@localhost does not match" &&
+
+               make_change_by_user usernamefile3 alice alice@localhost &&
+               P4EDITOR=cat P4USER=alice P4PASSWD=secret "$GITP4" |\
+               test_must_fail grep "git author.*does not match" &&
+
+               git config git-p4.skipUserNameCheck true &&
+               make_change_by_user usernamefile3 Charlie charlie@localhost &&
+               P4EDITOR=cat P4USER=alice P4PASSWD=secret "$GITP4" commit |\
+               test_must_fail grep "git author.*does not match" &&
+
+               p4_check_commit_author usernamefile3 alice
+       )
+'
+
+marshal_dump() {
+       what=$1
+       "$PYTHON_PATH" -c 'import marshal, sys; d = marshal.load(sys.stdin); print d["'$what'"]'
+}
+
+# Sleep a bit so that the top-most p4 change did not happen "now".  Then
+# import the repo and make sure that the initial import has the same time
+# as the top-most change.
+test_expect_success 'initial import time from top change time' '
+       p4change=$(p4 -G changes -m 1 //depot/... | marshal_dump change) &&
+       p4time=$(p4 -G changes -m 1 //depot/... | marshal_dump time) &&
+       sleep 3 &&
+       "$GITP4" clone --dest="$git" //depot &&
+       test_when_finished cleanup_git &&
+       (
+               cd "$git" &&
+               gittime=$(git show -s --raw --pretty=format:%at HEAD) &&
+               echo $p4time $gittime &&
+               test $p4time = $gittime
+       )
+'
+
+# Rename a file and confirm that rename is not detected in P4.
+# Rename the new file again with detectRenames option enabled and confirm that
+# this is detected in P4.
+# Rename the new file again adding an extra line, configure a big threshold in
+# detectRenames and confirm that rename is not detected in P4.
+# Repeat, this time with a smaller threshold and confirm that the rename is
+# detected in P4.
+test_expect_success 'detect renames' '
+       "$GITP4" clone --dest="$git" //depot@all &&
+       test_when_finished cleanup_git &&
+       (
+               cd "$git" &&
+               git config git-p4.skipSubmitEditCheck true &&
+
+               git mv file1 file4 &&
+               git commit -a -m "Rename file1 to file4" &&
+               git diff-tree -r -M HEAD &&
+               "$GITP4" submit &&
+               p4 filelog //depot/file4 &&
+               p4 filelog //depot/file4 | test_must_fail grep -q "branch from" &&
+
+               git mv file4 file5 &&
+               git commit -a -m "Rename file4 to file5" &&
+               git diff-tree -r -M HEAD &&
+               git config git-p4.detectRenames true &&
+               "$GITP4" submit &&
+               p4 filelog //depot/file5 &&
+               p4 filelog //depot/file5 | grep -q "branch from //depot/file4" &&
+
+               git mv file5 file6 &&
+               echo update >>file6 &&
+               git add file6 &&
+               git commit -a -m "Rename file5 to file6 with changes" &&
+               git diff-tree -r -M HEAD &&
+               level=$(git diff-tree -r -M HEAD | sed 1d | cut -f1 | cut -d" " -f5 | sed "s/R0*//") &&
+               test -n "$level" && test "$level" -gt 0 && test "$level" -lt 98 &&
+               git config git-p4.detectRenames $(($level + 2)) &&
+               "$GITP4" submit &&
+               p4 filelog //depot/file6 &&
+               p4 filelog //depot/file6 | test_must_fail grep -q "branch from" &&
+
+               git mv file6 file7 &&
+               echo update >>file7 &&
+               git add file7 &&
+               git commit -a -m "Rename file6 to file7 with changes" &&
+               git diff-tree -r -M HEAD &&
+               level=$(git diff-tree -r -M HEAD | sed 1d | cut -f1 | cut -d" " -f5 | sed "s/R0*//") &&
+               test -n "$level" && test "$level" -gt 2 && test "$level" -lt 100 &&
+               git config git-p4.detectRenames $(($level - 2)) &&
+               "$GITP4" submit &&
+               p4 filelog //depot/file7 &&
+               p4 filelog //depot/file7 | grep -q "branch from //depot/file6"
+       )
+'
+
+# Copy a file and confirm that copy is not detected in P4.
+# Copy a file with detectCopies option enabled and confirm that copy is not
+# detected in P4.
+# Modify and copy a file with detectCopies option enabled and confirm that copy
+# is detected in P4.
+# Copy a file with detectCopies and detectCopiesHarder options enabled and
+# confirm that copy is detected in P4.
+# Modify and copy a file, configure a bigger threshold in detectCopies and
+# confirm that copy is not detected in P4.
+# Modify and copy a file, configure a smaller threshold in detectCopies and
+# confirm that copy is detected in P4.
+test_expect_success 'detect copies' '
+       "$GITP4" clone --dest="$git" //depot@all &&
+       test_when_finished cleanup_git &&
+       (
+               cd "$git" &&
+               git config git-p4.skipSubmitEditCheck true &&
+
+               cp file2 file8 &&
+               git add file8 &&
+               git commit -a -m "Copy file2 to file8" &&
+               git diff-tree -r -C HEAD &&
+               "$GITP4" submit &&
+               p4 filelog //depot/file8 &&
+               p4 filelog //depot/file8 | test_must_fail grep -q "branch from" &&
+
+               cp file2 file9 &&
+               git add file9 &&
+               git commit -a -m "Copy file2 to file9" &&
+               git diff-tree -r -C HEAD &&
+               git config git-p4.detectCopies true &&
+               "$GITP4" submit &&
+               p4 filelog //depot/file9 &&
+               p4 filelog //depot/file9 | test_must_fail grep -q "branch from" &&
+
+               echo "file2" >>file2 &&
+               cp file2 file10 &&
+               git add file2 file10 &&
+               git commit -a -m "Modify and copy file2 to file10" &&
+               git diff-tree -r -C HEAD &&
+               "$GITP4" submit &&
+               p4 filelog //depot/file10 &&
+               p4 filelog //depot/file10 | grep -q "branch from //depot/file" &&
+
+               cp file2 file11 &&
+               git add file11 &&
+               git commit -a -m "Copy file2 to file11" &&
+               git diff-tree -r -C --find-copies-harder HEAD &&
+               src=$(git diff-tree -r -C --find-copies-harder HEAD | sed 1d | cut -f2) &&
+               test "$src" = file10 &&
+               git config git-p4.detectCopiesHarder true &&
+               "$GITP4" submit &&
+               p4 filelog //depot/file11 &&
+               p4 filelog //depot/file11 | grep -q "branch from //depot/file" &&
+
+               cp file2 file12 &&
+               echo "some text" >>file12 &&
+               git add file12 &&
+               git commit -a -m "Copy file2 to file12 with changes" &&
+               git diff-tree -r -C --find-copies-harder HEAD &&
+               level=$(git diff-tree -r -C --find-copies-harder HEAD | sed 1d | cut -f1 | cut -d" " -f5 | sed "s/C0*//") &&
+               test -n "$level" && test "$level" -gt 0 && test "$level" -lt 98 &&
+               src=$(git diff-tree -r -C --find-copies-harder HEAD | sed 1d | cut -f2) &&
+               test "$src" = file10 &&
+               git config git-p4.detectCopies $(($level + 2)) &&
+               "$GITP4" submit &&
+               p4 filelog //depot/file12 &&
+               p4 filelog //depot/file12 | test_must_fail grep -q "branch from" &&
+
+               cp file2 file13 &&
+               echo "different text" >>file13 &&
+               git add file13 &&
+               git commit -a -m "Copy file2 to file13 with changes" &&
+               git diff-tree -r -C --find-copies-harder HEAD &&
+               level=$(git diff-tree -r -C --find-copies-harder HEAD | sed 1d | cut -f1 | cut -d" " -f5 | sed "s/C0*//") &&
+               test -n "$level" && test "$level" -gt 2 && test "$level" -lt 100 &&
+               src=$(git diff-tree -r -C --find-copies-harder HEAD | sed 1d | cut -f2) &&
+               test "$src" = file10 &&
+               git config git-p4.detectCopies $(($level - 2)) &&
+               "$GITP4" submit &&
+               p4 filelog //depot/file13 &&
+               p4 filelog //depot/file13 | grep -q "branch from //depot/file"
+       )
+'
+
+test_expect_success 'kill p4d' '
+       kill_p4d
+'
+
+test_done
diff --git a/t/t9800-git-p4.sh b/t/t9800-git-p4.sh
deleted file mode 100755 (executable)
index 272de3f..0000000
+++ /dev/null
@@ -1,404 +0,0 @@
-#!/bin/sh
-
-test_description='git-p4 tests'
-
-. ./lib-git-p4.sh
-
-test_expect_success 'start p4d' '
-       start_p4d
-'
-
-test_expect_success 'add p4 files' '
-       (
-               cd "$cli" &&
-               echo file1 >file1 &&
-               p4 add file1 &&
-               p4 submit -d "file1" &&
-               echo file2 >file2 &&
-               p4 add file2 &&
-               p4 submit -d "file2"
-       )
-'
-
-test_expect_success 'basic git-p4 clone' '
-       "$GITP4" clone --dest="$git" //depot &&
-       test_when_finished cleanup_git &&
-       (
-               cd "$git" &&
-               git log --oneline >lines &&
-               test_line_count = 1 lines
-       )
-'
-
-test_expect_success 'git-p4 clone @all' '
-       "$GITP4" clone --dest="$git" //depot@all &&
-       test_when_finished cleanup_git &&
-       (
-               cd "$git" &&
-               git log --oneline >lines &&
-               test_line_count = 2 lines
-       )
-'
-
-test_expect_success 'git-p4 sync uninitialized repo' '
-       test_create_repo "$git" &&
-       test_when_finished cleanup_git &&
-       (
-               cd "$git" &&
-               test_must_fail "$GITP4" sync
-       )
-'
-
-#
-# Create a git repo by hand.  Add a commit so that HEAD is valid.
-# Test imports a new p4 repository into a new git branch.
-#
-test_expect_success 'git-p4 sync new branch' '
-       test_create_repo "$git" &&
-       test_when_finished cleanup_git &&
-       (
-               cd "$git" &&
-               test_commit head &&
-               "$GITP4" sync --branch=refs/remotes/p4/depot //depot@all &&
-               git log --oneline p4/depot >lines &&
-               test_line_count = 2 lines
-       )
-'
-
-test_expect_success 'exit when p4 fails to produce marshaled output' '
-       badp4dir="$TRASH_DIRECTORY/badp4dir" &&
-       mkdir "$badp4dir" &&
-       test_when_finished "rm \"$badp4dir/p4\" && rmdir \"$badp4dir\"" &&
-       cat >"$badp4dir"/p4 <<-EOF &&
-       #!$SHELL_PATH
-       exit 1
-       EOF
-       chmod 755 "$badp4dir"/p4 &&
-       PATH="$badp4dir:$PATH" "$GITP4" clone --dest="$git" //depot >errs 2>&1 ; retval=$? &&
-       test $retval -eq 1 &&
-       test_must_fail grep -q Traceback errs
-'
-
-test_expect_success 'add p4 files with wildcards in the names' '
-       (
-               cd "$cli" &&
-               echo file-wild-hash >file-wild#hash &&
-               echo file-wild-star >file-wild\*star &&
-               echo file-wild-at >file-wild@at &&
-               echo file-wild-percent >file-wild%percent &&
-               p4 add -f file-wild* &&
-               p4 submit -d "file wildcards"
-       )
-'
-
-test_expect_success 'wildcard files git-p4 clone' '
-       "$GITP4" clone --dest="$git" //depot &&
-       test_when_finished cleanup_git &&
-       (
-               cd "$git" &&
-               test -f file-wild#hash &&
-               test -f file-wild\*star &&
-               test -f file-wild@at &&
-               test -f file-wild%percent
-       )
-'
-
-test_expect_success 'clone bare' '
-       "$GITP4" clone --dest="$git" --bare //depot &&
-       test_when_finished cleanup_git &&
-       (
-               cd "$git" &&
-               test ! -d .git &&
-               bare=`git config --get core.bare` &&
-               test "$bare" = true
-       )
-'
-
-p4_add_user() {
-       name=$1 fullname=$2 &&
-       p4 user -f -i <<-EOF &&
-       User: $name
-       Email: $name@localhost
-       FullName: $fullname
-       EOF
-       p4 passwd -P secret $name
-}
-
-p4_grant_admin() {
-       name=$1 &&
-       {
-               p4 protect -o &&
-               echo "    admin user $name * //depot/..."
-       } | p4 protect -i
-}
-
-p4_check_commit_author() {
-       file=$1 user=$2 &&
-       p4 changes -m 1 //depot/$file | grep -q $user
-}
-
-make_change_by_user() {
-       file=$1 name=$2 email=$3 &&
-       echo "username: a change by $name" >>"$file" &&
-       git add "$file" &&
-       git commit --author "$name <$email>" -m "a change by $name"
-}
-
-# Test username support, submitting as user 'alice'
-test_expect_success 'preserve users' '
-       p4_add_user alice Alice &&
-       p4_add_user bob Bob &&
-       p4_grant_admin alice &&
-       "$GITP4" clone --dest="$git" //depot &&
-       test_when_finished cleanup_git &&
-       (
-               cd "$git" &&
-               echo "username: a change by alice" >>file1 &&
-               echo "username: a change by bob" >>file2 &&
-               git commit --author "Alice <alice@localhost>" -m "a change by alice" file1 &&
-               git commit --author "Bob <bob@localhost>" -m "a change by bob" file2 &&
-               git config git-p4.skipSubmitEditCheck true &&
-               P4EDITOR=touch P4USER=alice P4PASSWD=secret "$GITP4" commit --preserve-user &&
-               p4_check_commit_author file1 alice &&
-               p4_check_commit_author file2 bob
-       )
-'
-
-# Test username support, submitting as bob, who lacks admin rights. Should
-# not submit change to p4 (git diff should show deltas).
-test_expect_success 'refuse to preserve users without perms' '
-       "$GITP4" clone --dest="$git" //depot &&
-       test_when_finished cleanup_git &&
-       (
-               cd "$git" &&
-               git config git-p4.skipSubmitEditCheck true &&
-               echo "username-noperms: a change by alice" >>file1 &&
-               git commit --author "Alice <alice@localhost>" -m "perms: a change by alice" file1 &&
-               P4EDITOR=touch P4USER=bob P4PASSWD=secret test_must_fail "$GITP4" commit --preserve-user &&
-               test_must_fail git diff --exit-code HEAD..p4/master
-       )
-'
-
-# What happens with unknown author? Without allowMissingP4Users it should fail.
-test_expect_success 'preserve user where author is unknown to p4' '
-       "$GITP4" clone --dest="$git" //depot &&
-       test_when_finished cleanup_git &&
-       (
-               cd "$git" &&
-               git config git-p4.skipSubmitEditCheck true &&
-               echo "username-bob: a change by bob" >>file1 &&
-               git commit --author "Bob <bob@localhost>" -m "preserve: a change by bob" file1 &&
-               echo "username-unknown: a change by charlie" >>file1 &&
-               git commit --author "Charlie <charlie@localhost>" -m "preserve: a change by charlie" file1 &&
-               P4EDITOR=touch P4USER=alice P4PASSWD=secret test_must_fail "$GITP4" commit --preserve-user &&
-               test_must_fail git diff --exit-code HEAD..p4/master &&
-
-               echo "$0: repeat with allowMissingP4Users enabled" &&
-               git config git-p4.allowMissingP4Users true &&
-               git config git-p4.preserveUser true &&
-               P4EDITOR=touch P4USER=alice P4PASSWD=secret "$GITP4" commit &&
-               git diff --exit-code HEAD..p4/master &&
-               p4_check_commit_author file1 alice
-       )
-'
-
-# If we're *not* using --preserve-user, git-p4 should warn if we're submitting
-# changes that are not all ours.
-# Test: user in p4 and user unknown to p4.
-# Test: warning disabled and user is the same.
-test_expect_success 'not preserving user with mixed authorship' '
-       "$GITP4" clone --dest="$git" //depot &&
-       test_when_finished cleanup_git &&
-       (
-               cd "$git" &&
-               git config git-p4.skipSubmitEditCheck true &&
-               p4_add_user derek Derek &&
-
-               make_change_by_user usernamefile3 Derek derek@localhost &&
-               P4EDITOR=cat P4USER=alice P4PASSWD=secret "$GITP4" commit |\
-               grep "git author derek@localhost does not match" &&
-
-               make_change_by_user usernamefile3 Charlie charlie@localhost &&
-               P4EDITOR=cat P4USER=alice P4PASSWD=secret "$GITP4" commit |\
-               grep "git author charlie@localhost does not match" &&
-
-               make_change_by_user usernamefile3 alice alice@localhost &&
-               P4EDITOR=cat P4USER=alice P4PASSWD=secret "$GITP4" |\
-               test_must_fail grep "git author.*does not match" &&
-
-               git config git-p4.skipUserNameCheck true &&
-               make_change_by_user usernamefile3 Charlie charlie@localhost &&
-               P4EDITOR=cat P4USER=alice P4PASSWD=secret "$GITP4" commit |\
-               test_must_fail grep "git author.*does not match" &&
-
-               p4_check_commit_author usernamefile3 alice
-       )
-'
-
-marshal_dump() {
-       what=$1
-       "$PYTHON_PATH" -c 'import marshal, sys; d = marshal.load(sys.stdin); print d["'$what'"]'
-}
-
-# Sleep a bit so that the top-most p4 change did not happen "now".  Then
-# import the repo and make sure that the initial import has the same time
-# as the top-most change.
-test_expect_success 'initial import time from top change time' '
-       p4change=$(p4 -G changes -m 1 //depot/... | marshal_dump change) &&
-       p4time=$(p4 -G changes -m 1 //depot/... | marshal_dump time) &&
-       sleep 3 &&
-       "$GITP4" clone --dest="$git" //depot &&
-       test_when_finished cleanup_git &&
-       (
-               cd "$git" &&
-               gittime=$(git show -s --raw --pretty=format:%at HEAD) &&
-               echo $p4time $gittime &&
-               test $p4time = $gittime
-       )
-'
-
-# Rename a file and confirm that rename is not detected in P4.
-# Rename the new file again with detectRenames option enabled and confirm that
-# this is detected in P4.
-# Rename the new file again adding an extra line, configure a big threshold in
-# detectRenames and confirm that rename is not detected in P4.
-# Repeat, this time with a smaller threshold and confirm that the rename is
-# detected in P4.
-test_expect_success 'detect renames' '
-       "$GITP4" clone --dest="$git" //depot@all &&
-       test_when_finished cleanup_git &&
-       (
-               cd "$git" &&
-               git config git-p4.skipSubmitEditCheck true &&
-
-               git mv file1 file4 &&
-               git commit -a -m "Rename file1 to file4" &&
-               git diff-tree -r -M HEAD &&
-               "$GITP4" submit &&
-               p4 filelog //depot/file4 &&
-               p4 filelog //depot/file4 | test_must_fail grep -q "branch from" &&
-
-               git mv file4 file5 &&
-               git commit -a -m "Rename file4 to file5" &&
-               git diff-tree -r -M HEAD &&
-               git config git-p4.detectRenames true &&
-               "$GITP4" submit &&
-               p4 filelog //depot/file5 &&
-               p4 filelog //depot/file5 | grep -q "branch from //depot/file4" &&
-
-               git mv file5 file6 &&
-               echo update >>file6 &&
-               git add file6 &&
-               git commit -a -m "Rename file5 to file6 with changes" &&
-               git diff-tree -r -M HEAD &&
-               level=$(git diff-tree -r -M HEAD | sed 1d | cut -f1 | cut -d" " -f5 | sed "s/R0*//") &&
-               test -n "$level" && test "$level" -gt 0 && test "$level" -lt 98 &&
-               git config git-p4.detectRenames $(($level + 2)) &&
-               "$GITP4" submit &&
-               p4 filelog //depot/file6 &&
-               p4 filelog //depot/file6 | test_must_fail grep -q "branch from" &&
-
-               git mv file6 file7 &&
-               echo update >>file7 &&
-               git add file7 &&
-               git commit -a -m "Rename file6 to file7 with changes" &&
-               git diff-tree -r -M HEAD &&
-               level=$(git diff-tree -r -M HEAD | sed 1d | cut -f1 | cut -d" " -f5 | sed "s/R0*//") &&
-               test -n "$level" && test "$level" -gt 2 && test "$level" -lt 100 &&
-               git config git-p4.detectRenames $(($level - 2)) &&
-               "$GITP4" submit &&
-               p4 filelog //depot/file7 &&
-               p4 filelog //depot/file7 | grep -q "branch from //depot/file6"
-       )
-'
-
-# Copy a file and confirm that copy is not detected in P4.
-# Copy a file with detectCopies option enabled and confirm that copy is not
-# detected in P4.
-# Modify and copy a file with detectCopies option enabled and confirm that copy
-# is detected in P4.
-# Copy a file with detectCopies and detectCopiesHarder options enabled and
-# confirm that copy is detected in P4.
-# Modify and copy a file, configure a bigger threshold in detectCopies and
-# confirm that copy is not detected in P4.
-# Modify and copy a file, configure a smaller threshold in detectCopies and
-# confirm that copy is detected in P4.
-test_expect_success 'detect copies' '
-       "$GITP4" clone --dest="$git" //depot@all &&
-       test_when_finished cleanup_git &&
-       (
-               cd "$git" &&
-               git config git-p4.skipSubmitEditCheck true &&
-
-               cp file2 file8 &&
-               git add file8 &&
-               git commit -a -m "Copy file2 to file8" &&
-               git diff-tree -r -C HEAD &&
-               "$GITP4" submit &&
-               p4 filelog //depot/file8 &&
-               p4 filelog //depot/file8 | test_must_fail grep -q "branch from" &&
-
-               cp file2 file9 &&
-               git add file9 &&
-               git commit -a -m "Copy file2 to file9" &&
-               git diff-tree -r -C HEAD &&
-               git config git-p4.detectCopies true &&
-               "$GITP4" submit &&
-               p4 filelog //depot/file9 &&
-               p4 filelog //depot/file9 | test_must_fail grep -q "branch from" &&
-
-               echo "file2" >>file2 &&
-               cp file2 file10 &&
-               git add file2 file10 &&
-               git commit -a -m "Modify and copy file2 to file10" &&
-               git diff-tree -r -C HEAD &&
-               "$GITP4" submit &&
-               p4 filelog //depot/file10 &&
-               p4 filelog //depot/file10 | grep -q "branch from //depot/file" &&
-
-               cp file2 file11 &&
-               git add file11 &&
-               git commit -a -m "Copy file2 to file11" &&
-               git diff-tree -r -C --find-copies-harder HEAD &&
-               src=$(git diff-tree -r -C --find-copies-harder HEAD | sed 1d | cut -f2) &&
-               test "$src" = file10 &&
-               git config git-p4.detectCopiesHarder true &&
-               "$GITP4" submit &&
-               p4 filelog //depot/file11 &&
-               p4 filelog //depot/file11 | grep -q "branch from //depot/file" &&
-
-               cp file2 file12 &&
-               echo "some text" >>file12 &&
-               git add file12 &&
-               git commit -a -m "Copy file2 to file12 with changes" &&
-               git diff-tree -r -C --find-copies-harder HEAD &&
-               level=$(git diff-tree -r -C --find-copies-harder HEAD | sed 1d | cut -f1 | cut -d" " -f5 | sed "s/C0*//") &&
-               test -n "$level" && test "$level" -gt 0 && test "$level" -lt 98 &&
-               src=$(git diff-tree -r -C --find-copies-harder HEAD | sed 1d | cut -f2) &&
-               test "$src" = file10 &&
-               git config git-p4.detectCopies $(($level + 2)) &&
-               "$GITP4" submit &&
-               p4 filelog //depot/file12 &&
-               p4 filelog //depot/file12 | test_must_fail grep -q "branch from" &&
-
-               cp file2 file13 &&
-               echo "different text" >>file13 &&
-               git add file13 &&
-               git commit -a -m "Copy file2 to file13 with changes" &&
-               git diff-tree -r -C --find-copies-harder HEAD &&
-               level=$(git diff-tree -r -C --find-copies-harder HEAD | sed 1d | cut -f1 | cut -d" " -f5 | sed "s/C0*//") &&
-               test -n "$level" && test "$level" -gt 2 && test "$level" -lt 100 &&
-               src=$(git diff-tree -r -C --find-copies-harder HEAD | sed 1d | cut -f2) &&
-               test "$src" = file10 &&
-               git config git-p4.detectCopies $(($level - 2)) &&
-               "$GITP4" submit &&
-               p4 filelog //depot/file13 &&
-               p4 filelog //depot/file13 | grep -q "branch from //depot/file"
-       )
-'
-
-test_expect_success 'kill p4d' '
-       kill_p4d
-'
-
-test_done
diff --git a/t/t9803-git-p4-shell-metachars.sh b/t/t9803-git-p4-shell-metachars.sh
new file mode 100755 (executable)
index 0000000..db04375
--- /dev/null
@@ -0,0 +1,64 @@
+#!/bin/sh
+
+test_description='git-p4 transparency to shell metachars in filenames'
+
+. ./lib-git-p4.sh
+
+test_expect_success 'start p4d' '
+       start_p4d
+'
+
+test_expect_success 'init depot' '
+       (
+               cd "$cli" &&
+               echo file1 >file1 &&
+               p4 add file1 &&
+               p4 submit -d "file1"
+       )
+'
+
+test_expect_success 'shell metachars in filenames' '
+       "$GITP4" clone --dest="$git" //depot &&
+       test_when_finished cleanup_git &&
+       (
+               cd "$git" &&
+               git config git-p4.skipSubmitEditCheck true &&
+               echo f1 >foo\$bar &&
+               git add foo\$bar &&
+               echo f2 >"file with spaces" &&
+               git add "file with spaces" &&
+               git commit -m "add files" &&
+               P4EDITOR=touch "$GITP4" submit
+       ) &&
+       (
+               cd "$cli" &&
+               p4 sync ... &&
+               test -e "file with spaces" &&
+               test -e "foo\$bar"
+       )
+'
+
+test_expect_success 'deleting with shell metachars' '
+       "$GITP4" clone --dest="$git" //depot &&
+       test_when_finished cleanup_git &&
+       (
+               cd "$git" &&
+               git config git-p4.skipSubmitEditCheck true &&
+               git rm foo\$bar &&
+               git rm file\ with\ spaces &&
+               git commit -m "remove files" &&
+               P4EDITOR=touch "$GITP4" submit
+       ) &&
+       (
+               cd "$cli" &&
+               p4 sync ... &&
+               test ! -e "file with spaces" &&
+               test ! -e foo\$bar
+       )
+'
+
+test_expect_success 'kill p4d' '
+       kill_p4d
+'
+
+test_done
diff --git a/t/t9803-git-shell-metachars.sh b/t/t9803-git-shell-metachars.sh
deleted file mode 100755 (executable)
index db04375..0000000
+++ /dev/null
@@ -1,64 +0,0 @@
-#!/bin/sh
-
-test_description='git-p4 transparency to shell metachars in filenames'
-
-. ./lib-git-p4.sh
-
-test_expect_success 'start p4d' '
-       start_p4d
-'
-
-test_expect_success 'init depot' '
-       (
-               cd "$cli" &&
-               echo file1 >file1 &&
-               p4 add file1 &&
-               p4 submit -d "file1"
-       )
-'
-
-test_expect_success 'shell metachars in filenames' '
-       "$GITP4" clone --dest="$git" //depot &&
-       test_when_finished cleanup_git &&
-       (
-               cd "$git" &&
-               git config git-p4.skipSubmitEditCheck true &&
-               echo f1 >foo\$bar &&
-               git add foo\$bar &&
-               echo f2 >"file with spaces" &&
-               git add "file with spaces" &&
-               git commit -m "add files" &&
-               P4EDITOR=touch "$GITP4" submit
-       ) &&
-       (
-               cd "$cli" &&
-               p4 sync ... &&
-               test -e "file with spaces" &&
-               test -e "foo\$bar"
-       )
-'
-
-test_expect_success 'deleting with shell metachars' '
-       "$GITP4" clone --dest="$git" //depot &&
-       test_when_finished cleanup_git &&
-       (
-               cd "$git" &&
-               git config git-p4.skipSubmitEditCheck true &&
-               git rm foo\$bar &&
-               git rm file\ with\ spaces &&
-               git commit -m "remove files" &&
-               P4EDITOR=touch "$GITP4" submit
-       ) &&
-       (
-               cd "$cli" &&
-               p4 sync ... &&
-               test ! -e "file with spaces" &&
-               test ! -e foo\$bar
-       )
-'
-
-test_expect_success 'kill p4d' '
-       kill_p4d
-'
-
-test_done
diff --git a/t/t9805-git-p4-skip-submit-edit.sh b/t/t9805-git-p4-skip-submit-edit.sh
new file mode 100755 (executable)
index 0000000..df929e0
--- /dev/null
@@ -0,0 +1,104 @@
+#!/bin/sh
+
+test_description='git-p4 skipSubmitEdit config variables'
+
+. ./lib-git-p4.sh
+
+test_expect_success 'start p4d' '
+       start_p4d
+'
+
+test_expect_success 'init depot' '
+       (
+               cd "$cli" &&
+               echo file1 >file1 &&
+               p4 add file1 &&
+               p4 submit -d "change 1"
+       )
+'
+
+# this works because EDITOR is set to :
+test_expect_success 'no config, unedited, say yes' '
+       "$GITP4" clone --dest="$git" //depot &&
+       test_when_finished cleanup_git &&
+       (
+               cd "$git" &&
+               echo line >>file1 &&
+               git commit -a -m "change 2" &&
+               echo y | "$GITP4" submit &&
+               p4 changes //depot/... >wc &&
+               test_line_count = 2 wc
+       )
+'
+
+test_expect_success 'no config, unedited, say no' '
+       "$GITP4" clone --dest="$git" //depot &&
+       test_when_finished cleanup_git &&
+       (
+               cd "$git" &&
+               echo line >>file1 &&
+               git commit -a -m "change 3 (not really)" &&
+               printf "bad response\nn\n" | "$GITP4" submit &&
+               p4 changes //depot/... >wc &&
+               test_line_count = 2 wc
+       )
+'
+
+test_expect_success 'skipSubmitEdit' '
+       "$GITP4" clone --dest="$git" //depot &&
+       test_when_finished cleanup_git &&
+       (
+               cd "$git" &&
+               git config git-p4.skipSubmitEdit true &&
+               # will fail if editor is even invoked
+               git config core.editor /bin/false &&
+               echo line >>file1 &&
+               git commit -a -m "change 3" &&
+               "$GITP4" submit &&
+               p4 changes //depot/... >wc &&
+               test_line_count = 3 wc
+       )
+'
+
+test_expect_success 'skipSubmitEditCheck' '
+       "$GITP4" clone --dest="$git" //depot &&
+       test_when_finished cleanup_git &&
+       (
+               cd "$git" &&
+               git config git-p4.skipSubmitEditCheck true &&
+               echo line >>file1 &&
+               git commit -a -m "change 4" &&
+               "$GITP4" submit &&
+               p4 changes //depot/... >wc &&
+               test_line_count = 4 wc
+       )
+'
+
+# check the normal case, where the template really is edited
+test_expect_success 'no config, edited' '
+       "$GITP4" clone --dest="$git" //depot &&
+       test_when_finished cleanup_git &&
+       ed="$TRASH_DIRECTORY/ed.sh" &&
+       test_when_finished "rm \"$ed\"" &&
+       cat >"$ed" <<-EOF &&
+               #!$SHELL_PATH
+               sleep 1
+               touch "\$1"
+               exit 0
+       EOF
+       chmod 755 "$ed" &&
+       (
+               cd "$git" &&
+               echo line >>file1 &&
+               git commit -a -m "change 5" &&
+               EDITOR="\"$ed\"" "$GITP4" submit &&
+               p4 changes //depot/... >wc &&
+               test_line_count = 5 wc
+       )
+'
+
+test_expect_success 'kill p4d' '
+       kill_p4d
+'
+
+test_done
diff --git a/t/t9805-skip-submit-edit.sh b/t/t9805-skip-submit-edit.sh
deleted file mode 100755 (executable)
index df929e0..0000000
+++ /dev/null
@@ -1,104 +0,0 @@
-#!/bin/sh
-
-test_description='git-p4 skipSubmitEdit config variables'
-
-. ./lib-git-p4.sh
-
-test_expect_success 'start p4d' '
-       start_p4d
-'
-
-test_expect_success 'init depot' '
-       (
-               cd "$cli" &&
-               echo file1 >file1 &&
-               p4 add file1 &&
-               p4 submit -d "change 1"
-       )
-'
-
-# this works because EDITOR is set to :
-test_expect_success 'no config, unedited, say yes' '
-       "$GITP4" clone --dest="$git" //depot &&
-       test_when_finished cleanup_git &&
-       (
-               cd "$git" &&
-               echo line >>file1 &&
-               git commit -a -m "change 2" &&
-               echo y | "$GITP4" submit &&
-               p4 changes //depot/... >wc &&
-               test_line_count = 2 wc
-       )
-'
-
-test_expect_success 'no config, unedited, say no' '
-       "$GITP4" clone --dest="$git" //depot &&
-       test_when_finished cleanup_git &&
-       (
-               cd "$git" &&
-               echo line >>file1 &&
-               git commit -a -m "change 3 (not really)" &&
-               printf "bad response\nn\n" | "$GITP4" submit &&
-               p4 changes //depot/... >wc &&
-               test_line_count = 2 wc
-       )
-'
-
-test_expect_success 'skipSubmitEdit' '
-       "$GITP4" clone --dest="$git" //depot &&
-       test_when_finished cleanup_git &&
-       (
-               cd "$git" &&
-               git config git-p4.skipSubmitEdit true &&
-               # will fail if editor is even invoked
-               git config core.editor /bin/false &&
-               echo line >>file1 &&
-               git commit -a -m "change 3" &&
-               "$GITP4" submit &&
-               p4 changes //depot/... >wc &&
-               test_line_count = 3 wc
-       )
-'
-
-test_expect_success 'skipSubmitEditCheck' '
-       "$GITP4" clone --dest="$git" //depot &&
-       test_when_finished cleanup_git &&
-       (
-               cd "$git" &&
-               git config git-p4.skipSubmitEditCheck true &&
-               echo line >>file1 &&
-               git commit -a -m "change 4" &&
-               "$GITP4" submit &&
-               p4 changes //depot/... >wc &&
-               test_line_count = 4 wc
-       )
-'
-
-# check the normal case, where the template really is edited
-test_expect_success 'no config, edited' '
-       "$GITP4" clone --dest="$git" //depot &&
-       test_when_finished cleanup_git &&
-       ed="$TRASH_DIRECTORY/ed.sh" &&
-       test_when_finished "rm \"$ed\"" &&
-       cat >"$ed" <<-EOF &&
-               #!$SHELL_PATH
-               sleep 1
-               touch "\$1"
-               exit 0
-       EOF
-       chmod 755 "$ed" &&
-       (
-               cd "$git" &&
-               echo line >>file1 &&
-               git commit -a -m "change 5" &&
-               EDITOR="\"$ed\"" "$GITP4" submit &&
-               p4 changes //depot/... >wc &&
-               test_line_count = 5 wc
-       )
-'
-
-test_expect_success 'kill p4d' '
-       kill_p4d
-'
-
-test_done
diff --git a/t/t9807-git-p4-submit.sh b/t/t9807-git-p4-submit.sh
new file mode 100755 (executable)
index 0000000..2cb724e
--- /dev/null
@@ -0,0 +1,38 @@
+#!/bin/sh
+
+test_description='git-p4 submit'
+
+. ./lib-git-p4.sh
+
+test_expect_success 'start p4d' '
+       start_p4d
+'
+
+test_expect_success 'init depot' '
+       (
+               cd "$cli" &&
+               echo file1 >file1 &&
+               p4 add file1 &&
+               p4 submit -d "change 1"
+       )
+'
+
+test_expect_success 'submit with no client dir' '
+       test_when_finished cleanup_git &&
+       "$GITP4" clone --dest="$git" //depot &&
+       (
+               cd "$git" &&
+               echo file2 >file2 &&
+               git add file2 &&
+               git commit -m "git commit 2" &&
+               rm -rf "$cli" &&
+               git config git-p4.skipSubmitEdit true &&
+               "$GITP4" submit
+       )
+'
+
+test_expect_success 'kill p4d' '
+       kill_p4d
+'
+
+test_done
diff --git a/t/t9807-submit.sh b/t/t9807-submit.sh
deleted file mode 100755 (executable)
index 2cb724e..0000000
+++ /dev/null
@@ -1,38 +0,0 @@
-#!/bin/sh
-
-test_description='git-p4 submit'
-
-. ./lib-git-p4.sh
-
-test_expect_success 'start p4d' '
-       start_p4d
-'
-
-test_expect_success 'init depot' '
-       (
-               cd "$cli" &&
-               echo file1 >file1 &&
-               p4 add file1 &&
-               p4 submit -d "change 1"
-       )
-'
-
-test_expect_success 'submit with no client dir' '
-       test_when_finished cleanup_git &&
-       "$GITP4" clone --dest="$git" //depot &&
-       (
-               cd "$git" &&
-               echo file2 >file2 &&
-               git add file2 &&
-               git commit -m "git commit 2" &&
-               rm -rf "$cli" &&
-               git config git-p4.skipSubmitEdit true &&
-               "$GITP4" submit
-       )
-'
-
-test_expect_success 'kill p4d' '
-       kill_p4d
-'
-
-test_done
diff --git a/t/t9808-chdir.sh b/t/t9808-chdir.sh
deleted file mode 100755 (executable)
index eb8cc95..0000000
+++ /dev/null
@@ -1,49 +0,0 @@
-#!/bin/sh
-
-test_description='git-p4 relative chdir'
-
-. ./lib-git-p4.sh
-
-test_expect_success 'start p4d' '
-       start_p4d
-'
-
-test_expect_success 'init depot' '
-       (
-               cd "$cli" &&
-               echo file1 >file1 &&
-               p4 add file1 &&
-               p4 submit -d "change 1"
-       )
-'
-
-# P4 reads from P4CONFIG file to find its server params, if the
-# environment variable is set
-test_expect_success 'P4CONFIG and absolute dir clone' '
-       printf "P4PORT=$P4PORT\nP4CLIENT=$P4CLIENT\n" >p4config &&
-       test_when_finished "rm \"$TRASH_DIRECTORY/p4config\"" &&
-       test_when_finished cleanup_git &&
-       (
-               P4CONFIG=p4config && export P4CONFIG &&
-               unset P4PORT P4CLIENT &&
-               "$GITP4" clone --verbose --dest="$git" //depot
-       )
-'
-
-# same thing, but with relative directory name, note missing $ on --dest
-test_expect_success 'P4CONFIG and relative dir clone' '
-       printf "P4PORT=$P4PORT\nP4CLIENT=$P4CLIENT\n" >p4config &&
-       test_when_finished "rm \"$TRASH_DIRECTORY/p4config\"" &&
-       test_when_finished cleanup_git &&
-       (
-               P4CONFIG=p4config && export P4CONFIG &&
-               unset P4PORT P4CLIENT &&
-               "$GITP4" clone --verbose --dest="git" //depot
-       )
-'
-
-test_expect_success 'kill p4d' '
-       kill_p4d
-'
-
-test_done
diff --git a/t/t9808-git-p4-chdir.sh b/t/t9808-git-p4-chdir.sh
new file mode 100755 (executable)
index 0000000..eb8cc95
--- /dev/null
@@ -0,0 +1,49 @@
+#!/bin/sh
+
+test_description='git-p4 relative chdir'
+
+. ./lib-git-p4.sh
+
+test_expect_success 'start p4d' '
+       start_p4d
+'
+
+test_expect_success 'init depot' '
+       (
+               cd "$cli" &&
+               echo file1 >file1 &&
+               p4 add file1 &&
+               p4 submit -d "change 1"
+       )
+'
+
+# P4 reads from P4CONFIG file to find its server params, if the
+# environment variable is set
+test_expect_success 'P4CONFIG and absolute dir clone' '
+       printf "P4PORT=$P4PORT\nP4CLIENT=$P4CLIENT\n" >p4config &&
+       test_when_finished "rm \"$TRASH_DIRECTORY/p4config\"" &&
+       test_when_finished cleanup_git &&
+       (
+               P4CONFIG=p4config && export P4CONFIG &&
+               unset P4PORT P4CLIENT &&
+               "$GITP4" clone --verbose --dest="$git" //depot
+       )
+'
+
+# same thing, but with relative directory name, note missing $ on --dest
+test_expect_success 'P4CONFIG and relative dir clone' '
+       printf "P4PORT=$P4PORT\nP4CLIENT=$P4CLIENT\n" >p4config &&
+       test_when_finished "rm \"$TRASH_DIRECTORY/p4config\"" &&
+       test_when_finished cleanup_git &&
+       (
+               P4CONFIG=p4config && export P4CONFIG &&
+               unset P4PORT P4CLIENT &&
+               "$GITP4" clone --verbose --dest="git" //depot
+       )
+'
+
+test_expect_success 'kill p4d' '
+       kill_p4d
+'
+
+test_done